const t = require('tap')
const {spawn} = require('child_process')
const assert = require('assert')
t.test('nyc doing weird stuff...', (t) => {
  t.test('should be able to force kill if it times out', (t) => {
    let s = `
    process.on('SIGTERM', function() { console.log('ignore!') })
    process.on('SIGHUP', function() { console.log('hup!'); process.exit(1) })
    setInterval(function() {
      console.log('wtf')
    }, 40)
    `
    const args = ['-e', s.trim()]
    const scr = spawn('node', args)
    scr.stdout.setEncoding('utf8')
    scr.stderr.setEncoding('utf8')
    scr.stdout.on('data', (d) => {
      console.log(d)
    })
    scr.stderr.on('data', (d) => {
      console.log(d)
    })
    let gotStopped = false
    let forceKillTimeout
    function stop(cb) {
      scr.on('close', (code, signal) => {
        console.error('close', code, signal)
      })
      scr.on('exit', (exitCode, signal) => {
        clearTimeout(forceKillTimeout)
        cb(null, 'script killed in response to signal : ' + signal)
      })
      forceKillTimeout = setTimeout(() => scr.kill('SIGKILL'), 1000)
      scr.kill('SIGTERM')
    }
    setTimeout(() => {
      stop((err, status) => {
        if (err) throw err
        console.log(status)
        if (!t.assert(status.indexOf('SIGKILL') > -1)) {
          scr.kill('SIGKILL')
        }
        t.end()
      })
    }, 500)
  })
  t.end()
})
