const {spawn} = require('child_process')
const assert = require('assert')
describe('nyc doing weird stuff...', () => {
  it('should be able to force kill if it times out', (done) => {
    let s = `
    process.on('SIGTERM', function() { console.log('ignore!') })
    setInterval(function() {
      console.log('wtf')
    }, 40)
    `
    const args = ['-e', s.trim()]
    const scr = spawn('node', args)
    scr.stdout.setEncoding('utf8')
    scr.stderr.setEncoding('utf8')
    scr.stdout.on('data', (d) => {
      console.log(d)
    })
    scr.stderr.on('data', (d) => {
      console.log(d)
    })
    let gotStopped = false
    let forceKillTimeout
    function stop(cb) {
      scr.on('exit', (exitCode, signal) => {
        clearTimeout(forceKillTimeout)
        cb(null, 'script killed in response to signal : ' + signal)
      })
      forceKillTimeout = setTimeout(() => scr.kill('SIGKILL'), 1000)
      scr.kill()
    }
    setTimeout(() => {
      stop((err, status) => {
        if (err) return done(err)
        console.log(status)
        assert(status.indexOf('SIGKILL') > -1)
        done()
      })
    }, 150)
  })
})
